//  

#include<stdio.h>
#include<string.h>

struct node{
	node *parent;
	node *next[256];
	char *text[256];
	bool stop;
}tree;



node* NewNode()
{
	node *temp=new node; memset(temp,0,sizeof(node)); return temp;
}

void Remove(node *root=&tree)
{
	for(int n=0; n<256; n++) {
		if(root->text[n]) delete[]root->text[n];
		if(root->next[n]) Remove(root->next[n]),delete root->next[n];
	}
}





void Add(char *line,node *root=&tree)
{
	if(!*line) { root->stop=true; return;}
	int index=(unsigned char)*line; 
	node *temp=root->next[index]; char *text=root->text[index]; 
	if(!text) { root->text[index]=strdup(line); return;}
	while(*line && *text) if(*text!=*line) break; else text++,line++;
	if(!*text) { if(!temp) root->next[index]=temp=NewNode(),temp->parent=root; Add(line,root->next[index]); return;}
	temp=NewNode();
	if(*line) temp->text[(unsigned char)*line]=strdup(line); else temp->stop=true;
	temp->text[(unsigned char)*text]=strdup(text),*text=0;;
	temp->next[(unsigned char)*line]=root->next[index];
	root->next[index]=temp; temp->parent=root;
}


void Show(int id=0,node *root=&tree)
{
//	char buffer[70]; memset(buffer,' ',69); buff
	int n; bool first=true; //bool nline=true;
//	for(n=0; n<256; n++) if(root->next[n]) {nline=false; break;}
	for(n=0; n<256; n++) { char *text=root->text[n]; if(!text) continue;
		if(!first) for(int m=0; m<id; m++) putchar(' '); first=false;
		printf("%s",text); 
		if(root->next[n])Show(id+strlen(text),root->next[n]); else putchar('\n');
	}
	//if(count<2) putchar('\n');
}


void main()
{
	memset(&tree,0,sizeof(tree));
	Add("test");
	Add("potato");
	Add("tattoo");
	Add("theater");
	Add("tatu");
	Add("other");
	Add("text");
	Show();
	getchar();
}
